VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIDCEqualizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private m_objIDCEqualizer As IDCEqualizer

Public Property Get Object() As IDCEqualizer
    Set Object = m_objIDCEqualizer
End Property

Public Property Set Object(ByRef objIDCEqualizer As IDCEqualizer)
    Set m_objIDCEqualizer = objIDCEqualizer
End Property

Public Property Get Enabled() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCEqualizer.get_Enabled(lngReturn)
    Enabled = (lngReturn <> CLng(0))
End Property

Public Property Let Enabled(ByVal aEnabled As Boolean)
    Call m_objIDCEqualizer.set_Enabled(IIf(aEnabled, CLng(-1), CLng(0)))
End Property

Public Property Get Separate() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCEqualizer.get_Seperate(lngReturn)
    Separate = (lngReturn <> CLng(0))
End Property

Public Property Let Separate(ByVal aSeperate As Boolean)
    Call m_objIDCEqualizer.set_Seperate(IIf(aSeperate, CLng(-1), CLng(0)))
End Property

Public Property Get FFTSize() As TDCFFTSize
    Dim lngReturn As TDCFFTSize
    
    Call m_objIDCEqualizer.get_FFTSize(lngReturn)
End Property

Public Property Let FFTSize(ByVal aFFTSize As TDCFFTSize)
    Call m_objIDCEqualizer.set_FFTSize(aFFTSize)
End Property

Public Property Get Band(ByVal aChannel As Byte, ByVal aIndex As Byte) As Integer
    Dim bytReturn As Byte
    
    Call m_objIDCEqualizer.get_Band(aChannel, aIndex, bytReturn)
    Band = GetSignedByte(bytReturn)
End Property

Public Property Let Band(ByVal aChannel As Byte, ByVal aIndex As Byte, ByVal aBand As Integer)
    Call m_objIDCEqualizer.set_Band(aChannel, aIndex, GetUnsignedByte(aBand))
End Property

Private Function GetSignedByte(ByVal bytValue As Byte) As Integer
    If CInt(bytValue) <= CInt(127) Then
        GetSignedByte = CInt(bytValue)
    Else
        GetSignedByte = CInt(bytValue) - CInt(256)
    End If
End Function

Private Function GetUnsignedByte(ByVal intValue As Integer) As Byte
    If intValue < CInt(0) Then
        GetUnsignedByte = CByte(intValue + CInt(256))
    Else
        GetUnsignedByte = CByte(intValue)
    End If
End Function

